
// ==============================================================================================================================
//    Fresh!mindworkz Intro Skeleton - Import OpenGL & GLu Functions.
// ------------------------------------------------------------------------------------------------------------------------------
//    Copyright (C) 2002. Pasy & Pontscho & Remage / Fresh!mindworkz.
// ==============================================================================================================================

const
     GL_FALSE  				   = 0;
     GL_TRUE   				   = 1;
     GL_VENDOR                             = $1F00;
     GL_LIGHTING                           = $0B50;
     GL_LIGHT0                             = $4000;
     GL_QUADS                              = $0007;
     GL_ALPHA_TEST                         = $0BC0;
     GL_BACK                               = $0405;
     GL_SRC_COLOR                          = $0300;
     GL_ONE_MINUS_SRC_COLOR                = $0301;
     GL_CULL_FACE                          = $0B44;
     GL_TEXTURE_2D                         = $0DE1;
     GL_GREATER                            = $0204;
     GL_POINTS                             = $0000;
     GL_SRC_ALPHA                          = $0302;
     GL_LINEAR                             = $2601;
     GL_ONE_MINUS_SRC_ALPHA                = $0303;
     GL_POLYGON                            = $0009;
     GL_MODELVIEW                          = $1700;
     GL_ONE                                = 1;
     GL_BLEND                              = $0BE2;
     GL_TEXTURE                            = $1702;
     GL_PROJECTION                         = $1701;
     GL_POSITION                           = $1203;
     GL_DEPTH_TEST                         = $0B71;
     GL_FRONT                              = $0404;
     GL_SHININESS                          = $1601;
     GL_SMOOTH                             = $1D01;
     GL_NORMALIZE                          = $0BA1;
     GL_TEXTURE_MIN_FILTER                 = $2801;
     GL_UNSIGNED_BYTE                      = $1401;
     GL_TEXTURE_MAG_FILTER                 = $2800;
     GL_LINEAR_MIPMAP_LINEAR               = $2703;
     GL_RGB                                = $1907;
     GL_RGBA                               = $1908;

type
    pLongint  = ^Longint;

    PSingle   = ^Single;
    PDouble   = ^Double;

    GLvoid    = Pointer;
    GLboolean = Byte;

    GLbyte    = ShortInt; // 1-byte signed
    GLshort   = Integer;  // 2-byte signed
    GLint     = LongInt;  // 4-byte signed

    GLubyte   = Byte;     // 1-byte unsigned
    GLushort  = Word;     // 2-byte unsigned
    GLuint    = DWord;    // 4-byte signed

    GLsizei   = LongInt;  // 4-byte signed

    GLfloat   = Single;   // single precision float
    GLclampf  = Single;   // single precision float in [0,1]
    GLdouble  = Double;   // double precision float
    GLclampd  = Double;   // double precision float in [0,1]

    GLenum    = DWord;

    PGLBoolean = ^GLBoolean;
    PGLFloat   = ^GLfloat;
    PGLDouble  = ^GLDouble;

    GLbitfield = DWord;  { was an enum - no corresponding thing in pascal }



function wglCreateContext( _hDC: HDC ): HGLRC; stdcall;
  external 'OpenGL32.dll' name 'wglCreateContext';

function wglDeleteContext( _hGLRC: HGLRC ): winbool; stdcall;
  external 'OpenGL32.dll' name 'wglDeleteContext';

function wglMakeCurrent( _hDC: HDC; _hGLRC: HGLRC ): winbool; stdcall;
  external 'OpenGL32.dll' name 'wglMakeCurrent';

function wglSwapLayerBuffers( _hDC: HDC; _Planes: UINT ): winbool; stdcall;
  external 'OpenGL32.dll' name 'wglSwapLayerBuffers';

// ------------------------------------------------------------------------------------------------------------------------------

procedure glClear( _Mask: dword ); stdcall; 
	external 'OpenGL32.dll' name 'glClear';

procedure glClearColor( _Red, _Green, _Blue, _Alpha: single ); stdcall; 
	external 'OpenGL32.dll' name 'glClearColor';

procedure glEnd; stdcall; 
	external 'OpenGL32.dll' name 'glEnd';

procedure glBegin( mode : GLenum ); stdcall; 
	external 'OpenGL32.dll' name 'glBegin';

procedure glVertex3f( x, y, z : Single ); stdcall; 
	external 'OpenGL32.dll' name 'glVertex3f';

procedure glNormal3f( nx, ny, nz : Single ); stdcall; 
	external 'OpenGL32.dll' name 'glNormal3f';

procedure glEnable( cap : LongInt ); stdcall; 
	external 'OpenGL32.dll' name 'glEnable';

procedure glDisable( cap : LongInt ); stdcall; 
	external 'OpenGL32.dll' name 'glDisable';

procedure gluLookAt(eye, eyey, eyez, centerx, centery, centerz, upx, upy, upz: Double); stdcall; 
	external 'glu32.dll' name 'gluLookAt';

procedure gluPerspective(fovy, aspect, zNear, zFar: Double); stdcall; 
	external 'glu32.dll' name 'gluPerspective';

procedure gluBuild2DMipmaps(target: GLenum; components, width, height: LongInt; format, AType: GLEnum; var data); stdcall; 
	external 'glu32.dll' name 'gluBuild2DMipmaps';

procedure glLoadIdentity; stdcall; 
	external 'OpenGL32.dll' name 'glLoadIdentity';

procedure glRotatef( angle, x, y, z : Single ); stdcall; 
	external 'OpenGL32.dll' name 'glRotatef';

procedure glMatrixMode( mode : GLenum ); stdcall; 
	external 'OpenGL32.dll' name 'glMatrixMode';

procedure glTexCoord2f( s, t : Single ); stdcall; 
	external 'OpenGL32.dll' name 'glTexCoord2f';

procedure glColor3f( red, green, blue : Single ); stdcall; 
	external 'OpenGL32.dll' name 'glColor3f';

procedure glScalef( x, y, z : Single ); stdcall; 
	external 'OpenGL32.dll' name 'glScalef';

procedure glTranslatef( x, y, z : Single ); stdcall; 
	external 'OpenGL32.dll' name 'glTranslatef';

procedure glBlendFunc( sfactor, dfactor : GLenum ); stdcall; 
	external 'OpenGL32.dll' name 'glBlendFunc';

procedure glTexParameteri( target, pname : GLenum; param : LongInt ); stdcall; 
	external 'OpenGL32.dll' name 'glTexParameteri';

procedure glBindTexture( target : GLenum; texture : LongWord ); stdcall; 
	external 'OpenGL32.dll' name 'glBindTexture';

procedure glGenTextures( n : LongInt; var textures : LongWord ); stdcall; 
	external 'OpenGL32.dll' name 'glGenTextures';

procedure glDepthMask( flag : GLBoolean ); stdcall; 
	external 'OpenGL32.dll' name 'glDepthMask';

procedure glMateriali( face, pname : GLenum; param : LongInt ); stdcall; 
	external 'OpenGL32.dll' name 'glMateriali';

procedure glShadeModel( mode : GLenum ); stdcall; 
	external 'OpenGL32.dll' name 'glShadeModel';

procedure glLightfv( light, pname : GLenum; params  : PSingle ); stdcall; 
	external 'OpenGL32.dll' name 'glLightfv';

procedure glOrtho( left, right, bottom, top, near_val, far_val : Double ); stdcall; 
	external 'OpenGL32.dll' name 'glOrtho';

