function timeGetTime: Dword; stdcall; external 'winmm' name 'timeGetTime';


Procedure DrawSprite(centerx,centery,xs,ys: single);
begin
glbegin(gl_quads);
gltexcoord2f( 0, 0);glvertex3f(-xs+centerx,-ys+centery,0);
gltexcoord2f( 0, 1);glvertex3f(-xs+centerx, ys+centery,0);
gltexcoord2f( 1, 1);glvertex3f( xs+centerx, ys+centery,0);
gltexcoord2f( 1, 0);glvertex3f( xs+centerx,-ys+centery,0);
glend;
end;

Procedure GLOrthoIdent;
begin
glMatrixMode(GL_MODELVIEW);
glLoadIdentity;
glMatrixMode(GL_PROJECTION);
glLoadIdentity;
glortho(-1,1,-1,1,-10,10);
glMatrixMode(GL_MODELVIEW);
end;

procedure gldrawbox;
begin
glbegin(gl_quads);

glnormal3f( 0, 0,1);
glvertex3f( 1, 1,1);
glvertex3f( 1,-1,1);           
glvertex3f(-1,-1,1);
glvertex3f(-1, 1,1);	

glnormal3f( 0, 0,-1);
glvertex3f( 1, 1,-1);
glvertex3f( 1,-1,-1);
glvertex3f(-1,-1,-1);
glvertex3f(-1, 1,-1);	

glnormal3f( 1, 0, 0);
glvertex3f( 1, 1, 1);
glvertex3f( 1,-1, 1);
glvertex3f( 1,-1,-1);
glvertex3f( 1, 1,-1);	

glnormal3f(-1, 0, 0);
glvertex3f(-1, 1, 1);
glvertex3f(-1,-1, 1);
glvertex3f(-1,-1,-1);
glvertex3f(-1, 1,-1);  

glnormal3f( 0, 1, 0);
glvertex3f( 1, 1, 1);
glvertex3f( 1, 1,-1);
glvertex3f(-1, 1,-1);
glvertex3f(-1, 1, 1);	

glnormal3f( 0, -1, 0);
glvertex3f( 1, -1, 1);
glvertex3f( 1, -1,-1);
glvertex3f(-1, -1,-1);
glvertex3f(-1, -1, 1);	
glend;
end;

Procedure NewParticle(X,Y,Z,DX,DY,DZ,R,G,B,P,size:single;CamPos,CamTrg:vector);
Begin
Getmem(LastParticle[0].Next,Sizeof(Tparticle));
Lastparticle[0].Next[0].Prev:= Lastparticle;
LastParticle[0].Next[0].Next:= NIL;
LastParticle := lastParticle[0].Next;

LastParticle[0].dx := dx;
LastParticle[0].dy := dy;
LastParticle[0].dz := dz;

LastParticle[0].x := x;
LastParticle[0].y := y;
LastParticle[0].z := z;

LastParticle[0].CamPos := CamPos;
LastParticle[0].CamTrg := CamTrg;


LastParticle[0].r := r;
LastParticle[0].g := g;
LastParticle[0].b := b;
LastParticle[0].power := p;
LastParticle[0].size := size;
end;

Procedure DeleteParticle;
var TP : ^Tparticle;
Begin
if p[0].prev <> NIL then
p[0].prev[0].next:= p[0].next else particles := p[0].next;
if p[0].next <> NIL then
p[0].next[0].prev :=p[0].prev else lastparticle := p[0].prev;
TP :=p;
if p[0].prev <> NIL then
p := p[0].prev else p:=p[0].next;
freemem(tp,Sizeof(Tparticle));
end;

procedure vector_Make( var Vec3: vector; X,Y,Z: Single );
begin
  Vec3.X := X;
  Vec3.Y := Y;
  Vec3.Z := Z;
end;

// --------------------------------------------------------------------------

procedure vector_Sub( var Vec3: vector; In1, In2: vector );
begin
  Vec3.X := In1.X - In2.X;
  Vec3.Y := In1.Y - In2.Y;
  Vec3.Z := In1.Z - In2.Z;
end;

// --------------------------------------------------------------------------

procedure vector_Cross( var Vec3: vector; In1, In2: vector );
begin
  Vec3.X := In1.Y * In2.Z - In1.Z * In2.Y;
  Vec3.Y := In1.Z * In2.X - In1.X * In2.Z;
  Vec3.Z := In1.X * In2.Y - In1.Y * In2.X;
end;

// --------------------------------------------------------------------------

procedure vector_Normalize( var Vec3: vector );
var
  Len: Single;
begin
  Len := Sqrt( Sqr( Vec3.X ) + Sqr( Vec3.Y ) + Sqr( Vec3.Z ));
  if ( Len < 0.0001 ) then Exit;
  Vec3.X := Vec3.X / Len;
  Vec3.Y := Vec3.Y / Len;
  Vec3.Z := Vec3.Z / Len;
end;

// --------------------------------------------------------------------------

procedure vector_Scale( var Vec3: vector; Size: Single );
begin
  Vec3.X := Vec3.X * Size;
  Vec3.Y := Vec3.Y * Size;
  Vec3.Z := Vec3.Z * Size;
end;

Procedure GLdrawobj(obj: _3d_obj);
var i : longint;
    a,b,c : longint;
begin
for i := 0 to obj.faces-1 do
 begin
	a := obj.face[i].a;  
	b := obj.face[i].b;  
	c := obj.face[i].c;  
  glbegin(gl_polygon);
  glnormal3f(obj.normal[i].x,obj.normal[i].y,obj.normal[i].z);
  glvertex3f(obj.vertex[a].x,obj.vertex[a].y,obj.vertex[a].z);
  glvertex3f(obj.vertex[b].x,obj.vertex[b].y,obj.vertex[b].z);
  glvertex3f(obj.vertex[c].x,obj.vertex[c].y,obj.vertex[c].z);
  glend;

 end;
end;


procedure glcalcnormal(var obj:_3d_obj);
var rx1,ry1,rz1,rx2,ry2,rz2 : single;
	i : longint;
begin
for i := 0 to obj.faces-1 do 
	begin 
	RX1 := obj.vertex[obj.face[i].b].x-obj.vertex[obj.face[i].a].x;
	RY1 := obj.vertex[obj.face[i].b].y-obj.vertex[obj.face[i].a].y;
	RZ1 := obj.vertex[obj.face[i].b].z-obj.vertex[obj.face[i].a].z;
	RX2 := obj.vertex[obj.face[i].c].x-obj.vertex[obj.face[i].a].x;
	RY2 := obj.vertex[obj.face[i].c].y-obj.vertex[obj.face[i].a].y;
	RZ2 := obj.vertex[obj.face[i].c].z-obj.vertex[obj.face[i].a].z;
	obj.normal[i].x:=(RY1*RZ2-RY2*RZ1);
	obj.normal[i].y:=(RZ1*RX2-RZ2*RX1);
	obj.normal[i].z:=(RX1*RY2-RX2*RY1);
	end;
end;

procedure Copy3DObject(Var src,dst:_3d_obj);
var i : longint;
begin
dst.vertices := src.vertices;
dst.faces := src.faces;
getmem(dst.face  ,dst.faces*sizeof(_face));
getmem(dst.normal,dst.faces*sizeof(vector));
getmem(dst.vertex,dst.vertices*sizeof(vector));

for i := 0 to dst.faces-1 do
 begin
  dst.face[i] := src.face[i];
  dst.normal[i] := src.normal[i];
 end;

for i := 0 to dst.vertices-1 do
  dst.vertex[i] := src.vertex[i];
end;

Procedure GLdrawobjfaced(obj: _3d_obj);
var i : longint;
    a,b,c : longint;
begin
for i := 0 to (obj.faces div 2)-1 do
 begin
	a := obj.face[i*2].a;  
	b := obj.face[i*2].b;  
	c := obj.face[i*2].c;  

  glnormal3f(	obj.normal[i*2].x+obj.normal[i*2+1].x,
		obj.normal[i*2].y+obj.normal[i*2+1].y,
		obj.normal[i*2].z+obj.normal[i*2+1].z);

  glbegin(gl_polygon);
  glvertex3f(obj.vertex[a].x,obj.vertex[a].y,obj.vertex[a].z);
  glvertex3f(obj.vertex[b].x,obj.vertex[b].y,obj.vertex[b].z);
  glvertex3f(obj.vertex[c].x,obj.vertex[c].y,obj.vertex[c].z);
  glend;

	a := obj.face[i*2+1].a;  
	b := obj.face[i*2+1].b;  
	c := obj.face[i*2+1].c;  

  glbegin(gl_polygon);
  glvertex3f(obj.vertex[a].x,obj.vertex[a].y,obj.vertex[a].z);
  glvertex3f(obj.vertex[b].x,obj.vertex[b].y,obj.vertex[b].z);
  glvertex3f(obj.vertex[c].x,obj.vertex[c].y,obj.vertex[c].z);
  glend;

 end;
end;

Procedure CenterObject3D(var obj : _3d_obj);
var sumx,sumy,sumz : single;
    i : longint;
begin
sumx := 0;
sumz := 0;
sumy := 0;
for i := 0 to obj.vertices-1 do
 begin
 sumx := sumx+obj.vertex[i].x;
 sumy := sumy+obj.vertex[i].y;
 sumz := sumz+obj.vertex[i].z;
 end;

sumx := sumx / obj.vertices;
sumy := sumy / obj.vertices;
sumz := sumz / obj.vertices;

sumx := 0-sumx;
sumy := 0-sumy;
sumz := 0-sumz;

for i := 0 to obj.vertices-1 do
 begin
 obj.vertex[i].x := obj.vertex[i].x +sumx;
 obj.vertex[i].y := obj.vertex[i].y +sumy;
 obj.vertex[i].z := obj.vertex[i].z +sumz;
 end;
end;



